/*
    scx-xx: Samsung SCX-4200 scanner driver
    Copyright (C) 2007 Vladimir Koutny

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

#ifndef __SAMS_H__
#define __SAMS_H__

// Commands
enum SamsCommand {
    cmd_DeviceInfo,
    cmd_StartConfig,
    cmd_Config,
    cmd_Start,
    cmd_Stop,
    cmd_Status,
    cmd_SendData
};

// States
enum SamsState {
    st_Idle,
    st_StartConfig,
    st_DoConfig,
    st_PreScan,
    st_Scanning,
    st_PostScan,
    st_Done
};

// Events
enum SamsEvent {
    ev_None,
    ev_Ok,
    ev_Data,
    ev_DataLast,
    ev_NoData,
    ev_DeviceInfo,
    ev_Error,
    ev_Unknown
};

enum SamsColors {
    col_Grayscale = 0x03,
    col_Truecolor = 0x05,
    col_Lineart   = 0x00,
    col_Halftone  = 0x01
};

enum SamsResolution {
    res_75dpi  = 0x0000,
    res_100dpi = 0x0A0A,
    res_150dpi = 0x0202,
    res_200dpi = 0x0909,
    res_300dpi = 0x0505,
    res_600dpi = 0x0707
};

#define SAMS_CONF_WIDTH    5
#define SAMS_CONF_HEIGHT   9
#define SAMS_CONF_RES     13
#define SAMS_CONF_LEFT    15
#define SAMS_CONF_TOP     17
#define SAMS_CONF_COLOR   19

#define SAMS_DATA_SIZE     4
#define SAMS_DATA_HEIGHT   8 
#define SAMS_DATA_WIDTH   10

#endif /* __SAMS_H__ */

